# all files / ol/interaction/ dragboxinteraction.js

55.56% Statements 30/54
25% Branches 5/20
42.86% Functions 3/7
55.56% Lines 30/54

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    120×

    120×

    120×

    120×

    120×

    120×

    1×

    1×

    1×

    1×
    1×

    1×

    1×

    1×
    60×
    60×

     // FIXME draw drag box
    goog.provide('ol.DragBoxEvent');
    goog.provide('ol.interaction.DragBox');

    goog.require('goog.events.Event');
    goog.require('ol');
    goog.require('ol.events.ConditionType');
    goog.require('ol.events.condition');
    goog.require('ol.interaction.Pointer');
    goog.require('ol.render.Box');

    /**
     * @const
     * @type {number}
     */
    ol.DRAG_BOX_HYSTERESIS_PIXELS_SQUARED =
        ol.DRAG_BOX_HYSTERESIS_PIXELS *
        ol.DRAG_BOX_HYSTERESIS_PIXELS;

    /**
     * @enum {string}
     */
    ol.DragBoxEventType = {
      /**
       * Triggered upon drag box start.
       * @event ol.DragBoxEvent#boxstart
       * @api stable
       */
      BOXSTART: 'boxstart',
      /**
       * Triggered upon drag box end.
       * @event ol.DragBoxEvent#boxend
       * @api stable
       */
      BOXEND: 'boxend'
    };

    /**
     * @classdesc
     * Events emitted by {@link ol.interaction.DragBox} instances are instances of
     * this type.
     *
     * @param {string} type The event type.
     * @param {ol.Coordinate} coordinate The event coordinate.
     * @param {ol.MapBrowserEvent} mapBrowserEvent Originating event.
     * @extends {goog.events.Event}
     * @constructor
     * @implements {oli.DragBoxEvent}
     */
    ol.DragBoxEvent = function(type, coordinate, mapBrowserEvent) {
      goog.base(this, type);

      /**
       * The coordinate of the drag event.
       * @const
       * @type {ol.Coordinate}
       * @api stable
       */
      this.coordinate = coordinate;

      /**
       * @const
       * @type {ol.MapBrowserEvent}
       * @api
       */
      this.mapBrowserEvent = mapBrowserEvent;

    };
    goog.inherits(ol.DragBoxEvent, goog.events.Event);

    /**
     * A function that takes a {@link ol.MapBrowserEvent} and two
     * {@link ol.Pixel}s and returns a `{boolean}`. If the condition is met,
     * true should be returned.
     * @typedef {function(ol.MapBrowserEvent, ol.Pixel, ol.Pixel):boolean}
     * @api
     */
    ol.interaction.DragBoxEndConditionType;

    /**
     * @classdesc
     * Allows the user to draw a vector box by clicking and dragging on the map,
     * normally combined with an {@link ol.events.condition} that limits
     * it to when the shift or other key is held down. This is used, for example,
     * for zooming to a specific area of the map
     * (see {@link ol.interaction.DragZoom} and
     * {@link ol.interaction.DragRotateAndZoom}).
     *
     * This interaction is only supported for mouse devices.
     *
     * @constructor
     * @extends {ol.interaction.Pointer}
     * @fires ol.DragBoxEvent
     * @param {olx.interaction.DragBoxOptions=} opt_options Options.
     * @api stable
     */
    ol.interaction.DragBox = function(opt_options) {

      goog.base(this, {
        handleDownEvent: ol.interaction.DragBox.handleDownEvent_,
        handleDragEvent: ol.interaction.DragBox.handleDragEvent_,
        handleUpEvent: ol.interaction.DragBox.handleUpEvent_
      });

      var options = opt_options ? opt_options : {};

      /**
       * @type {ol.render.Box}
       * @private
       */
      this.box_ = new ol.render.Box(options.className || 'ol-dragbox');

      /**
       * @type {ol.Pixel}
       * @private
       */
      this.startPixel_ = null;

      /**
       * @private
       * @type {ol.events.ConditionType}
       */
      this.condition_ = options.condition ?
          options.condition : ol.events.condition.always;

      /**
       * @private
       * @type {ol.interaction.DragBoxEndConditionType}
       */
      this.boxEndCondition_ = options.boxEndCondition ?
          options.boxEndCondition : ol.interaction.DragBox.defaultBoxEndCondition;
    };
    goog.inherits(ol.interaction.DragBox, ol.interaction.Pointer);

    /**
     * The default condition for determining whether the boxend event
     * should fire.
     * @param  {ol.MapBrowserEvent} mapBrowserEvent The originating MapBrowserEvent
     *  leading to the box end.
     * @param  {ol.Pixel} startPixel      The starting pixel of the box.
     * @param  {ol.Pixel} endPixel        The end pixel of the box.
     * @return {boolean} Whether or not the boxend condition should be fired.
     */
    ol.interaction.DragBox.defaultBoxEndCondition = function(mapBrowserEvent,
        startPixel, endPixel) {
      var width = endPixel[0] - startPixel[0];
      var height = endPixel[1] - startPixel[1];
      return width * width + height * height >=
          ol.DRAG_BOX_HYSTERESIS_PIXELS_SQUARED;
    };

    /**
     * @param {ol.MapBrowserPointerEvent} mapBrowserEvent Event.
     * @this {ol.interaction.DragBox}
     * @private
     */
    ol.interaction.DragBox.handleDragEvent_ = function(mapBrowserEvent) {
      if (!ol.events.condition.mouseOnly(mapBrowserEvent)) {
        return;
      }

      this.box_.setPixels(this.startPixel_, mapBrowserEvent.pixel);
    };

    /**
     * Returns geometry of last drawn box.
     * @return {ol.geom.Polygon} Geometry.
     * @api stable
     */
    ol.interaction.DragBox.prototype.getGeometry = function() {
      return this.box_.getGeometry();
    };

    /**
     * To be overriden by child classes.
     * FIXME: use constructor option instead of relying on overridding.
     * @param {ol.MapBrowserEvent} mapBrowserEvent Map browser event.
     * @protected
     */
    ol.interaction.DragBox.prototype.onBoxEnd = ol.nullFunction;

    /**
     * @param {ol.MapBrowserPointerEvent} mapBrowserEvent Event.
     * @return {boolean} Stop drag sequence?
     * @this {ol.interaction.DragBox}
     * @private
     */
    ol.interaction.DragBox.handleUpEvent_ = function(mapBrowserEvent) {
      if (!ol.events.condition.mouseOnly(mapBrowserEvent)) {
        return true;
      }

      this.box_.setMap(null);

      if (this.boxEndCondition_(mapBrowserEvent,
          this.startPixel_, mapBrowserEvent.pixel)) {
        this.onBoxEnd(mapBrowserEvent);
        this.dispatchEvent(new ol.DragBoxEvent(ol.DragBoxEventType.BOXEND,
            mapBrowserEvent.coordinate, mapBrowserEvent));
      }
      return false;
    };

    /**
     * @param {ol.MapBrowserPointerEvent} mapBrowserEvent Event.
     * @return {boolean} Start drag sequence?
     * @this {ol.interaction.DragBox}
     * @private
     */
    ol.interaction.DragBox.handleDownEvent_ = function(mapBrowserEvent) {
      Eif (!ol.events.condition.mouseOnly(mapBrowserEvent)) {
        return false;
      }

      var browserEvent = mapBrowserEvent.browserEvent;
      if (browserEvent.isMouseActionButton() && this.condition_(mapBrowserEvent)) {
        this.startPixel_ = mapBrowserEvent.pixel;
        this.box_.setMap(mapBrowserEvent.map);
        this.box_.setPixels(this.startPixel_, this.startPixel_);
        this.dispatchEvent(new ol.DragBoxEvent(ol.DragBoxEventType.BOXSTART,
            mapBrowserEvent.coordinate, mapBrowserEvent));
        return true;
      } else {
        return false;
      }
    };